searchData={"items":[{"type":"module","title":"Endon","doc":"Endon is an Elixir library that provides helper functions for [Ecto](https://hexdocs.pm/ecto/getting-started.html#content),\nwith some inspiration from Ruby on Rails' [ActiveRecord](https://guides.rubyonrails.org/active_record_basics.html).\n\nIt's designed to be used within a module that is an `Ecto.Schema` and provides helpful [functions](`Endon.Functions`).\n\nSee the [overview](readme.html) and [features page](features.html) for examples.","ref":"Endon.html"},{"type":"module","title":"Endon.Functions","doc":"This module is a placeholder to show the function documentation.","ref":"Endon.Functions.html"},{"type":"function","title":"Endon.Functions.aggregate/3","doc":"Calculate the given aggregate over the given column.\n\n`conditions` are anything accepted by `where/2` (including a `t:Ecto.Query.t/0`).","ref":"Endon.Functions.html#aggregate/3"},{"type":"function","title":"Endon.Functions.all/1","doc":"Fetches all entries from the data store matching the given query.\n\nLimit results to those matching these conditions.  Value can be\nanything accepted by `where/2` (including a `t:Ecto.Query.t/0`).","ref":"Endon.Functions.html#all/1"},{"type":"function","title":"Options - Endon.Functions.all/1","doc":"* `:order_by` - By default, orders by primary key ascending\n  * `:preload` - A list of fields to preload, much like `c:Ecto.Repo.preload/3`\n  * `:offset` - Number to offset by","ref":"Endon.Functions.html#all/1-options"},{"type":"function","title":"Endon.Functions.avg/2","doc":"Get the average of a given column.\n\n`conditions` are anything accepted by `where/2` (including a `t:Ecto.Query.t/0`).","ref":"Endon.Functions.html#avg/2"},{"type":"function","title":"Endon.Functions.count/2","doc":"Get a count of all records matching the conditions.\n\nYou can give an optional column;\nif none is specified, then it's the equivalent of a `select count(*)`.\n\n`conditions` are anything accepted by `where/2` (including a `t:Ecto.Query.t/0`).","ref":"Endon.Functions.html#count/2"},{"type":"function","title":"Endon.Functions.create/1","doc":"Insert a new record into the data store.\n\n`params` can be either a `Keyword` list, a `Map` of attributes and values, or a struct\nof the same type being used to invoke `create/1`\n\nReturns `{:ok, struct}` if one is created, or `{:error, changeset}` if there is\na validation error.","ref":"Endon.Functions.html#create/1"},{"type":"function","title":"Endon.Functions.create!/1","doc":"Insert a new record into the data store.\n\n`params` can be either a `Keyword` list, a `Map` of attributes and values, or a struct\nof the same type being used to invoke `create!/1`\n\nReturns the struct if created, or raises a `Ecto.InvalidChangesetError` if there was\na validation error.","ref":"Endon.Functions.html#create!/1"},{"type":"function","title":"Endon.Functions.delete/1","doc":"Delete a record in the data store.\n\nThe `struct` must be a `t:Ecto.Schema.t/0` (your module that uses `Ecto.Schema`).\n\nReturns `{:ok, struct}` if the record is deleted, or `{:error, changeset}` if there is\na validation error.","ref":"Endon.Functions.html#delete/1"},{"type":"function","title":"Endon.Functions.delete!/1","doc":"Delete a record in the data store.\n\nThe `struct` must be a `t:Ecto.Schema.t/0` (your module that uses `Ecto.Schema`).\n\nReturns the struct if it was deleted, or raises a `Ecto.InvalidChangesetError` if there was\na validation error.","ref":"Endon.Functions.html#delete!/1"},{"type":"function","title":"Endon.Functions.delete_where/1","doc":"Delete multiple records in the data store based on conditions.\n\nDelete all the records that match the given `conditions` (the same as for `where/2`).\n\n**Note:** If you don't supply any conditions, _all_ records will be deleted.\n\nIt returns a tuple containing the number of entries and any returned result as second element.\nThe second element is nil by default unless a select is supplied in the update query.","ref":"Endon.Functions.html#delete_where/1"},{"type":"function","title":"Examples - Endon.Functions.delete_where/1","doc":"# this line using Ecto.Repo\n    from(p in Post, where: p.user_id == 123) |> MyRepo.delete_all\n\n    # is the same as this line in Endon\n    Post.delete_where(user_id: 123)","ref":"Endon.Functions.html#delete_where/1-examples"},{"type":"function","title":"Endon.Functions.exists?/1","doc":"Checks if there exists an entry that matches the given query.\n\n`conditions` are the same as those accepted by `where/2`.","ref":"Endon.Functions.html#exists?/1"},{"type":"function","title":"Endon.Functions.fetch/2","doc":"Fetches one or more structs from the data store based on the primary key(s) given.\n\nIf one primary key is given, then one struct will be returned (or `:error` if not found)\n\nIf more than one primary key value is given in a list, then all of the structs with those ids\nwill be returned (and `:error` will be returned if any one of the primary\nkeys can't be found).\n\nWill raise an exception if the module doesn't have a primary key defined, or if it is a\ncomposite primary key.","ref":"Endon.Functions.html#fetch/2"},{"type":"function","title":"Options - Endon.Functions.fetch/2","doc":"* `:preload` - A list of fields to preload, much like `c:Ecto.Repo.preload/3`\n  * `:lock` - Row level lock in the select. Currently only `:for_update` is supported.","ref":"Endon.Functions.html#fetch/2-options"},{"type":"function","title":"Endon.Functions.find/2","doc":"Fetches one or more structs from the data store based on the primary key(s) given.\n\nMuch like `fetch/2`, except an error is raised if the record(s) can't be found.\n\nIf one primary key is given, then one struct will be returned (or a `Ecto.NoResultsError`\nraised if a match isn't found).\n\nIf more than one primary key is given in a list, then all of the structs with those ids\nwill be returned (and a `Ecto.NoResultsError` will be raised if any one of the primary\nkeys can't be found).\n\nWill raise an exception if the module doesn't have a primary key defined, or if it is a\ncomposite primary key.","ref":"Endon.Functions.html#find/2"},{"type":"function","title":"Options - Endon.Functions.find/2","doc":"* `:preload` - A list of fields to preload, much like `c:Ecto.Repo.preload/3`\n * `:lock` - Row level lock in the select. Currently only `:for_update` is supported.","ref":"Endon.Functions.html#find/2-options"},{"type":"function","title":"Endon.Functions.find_by/2","doc":"Find a single record based on given conditions.\n\nIf a record can't be found, then `nil` is returned.","ref":"Endon.Functions.html#find_by/2"},{"type":"function","title":"Options - Endon.Functions.find_by/2","doc":"* `:preload` - A list of fields to preload, much like `c:Ecto.Repo.preload/3`\n  * `:lock` - Row level lock in the select. Currently only `:for_update` is supported.","ref":"Endon.Functions.html#find_by/2-options"},{"type":"function","title":"Endon.Functions.find_or_create_by/1","doc":"Find or create a record based on specific attributes values.\n\nSimilar to `find_by`, except that if a record cannot be found with the given attributes\nthen a new one will be created.\n\nReturns `{:ok, struct}` if one is found/created, or `{:error, changeset}` if there is\na validation error.","ref":"Endon.Functions.html#find_or_create_by/1"},{"type":"function","title":"Endon.Functions.first/2","doc":"Get the first `count` records.\n\nIf you ask for one thing (`count` of 1),\nyou will get back the first record or `nil` if none are found.  If you ask for more\nthan one thing (`count` > 1), you'll get back a list of 0 or more records.\n\nIf no order is defined it will order by primary key ascending.","ref":"Endon.Functions.html#first/2"},{"type":"function","title":"Options - Endon.Functions.first/2","doc":"* `:order_by` - By default, orders by primary key ascending\n  * `:conditions` - Limit results to those matching these conditions.  Value can be\n    anything accepted by `where/2` (including a `t:Ecto.Query.t/0`).\n\nIf there is no primary key for the table then `:order_by` must be provided.","ref":"Endon.Functions.html#first/2-options"},{"type":"function","title":"Examples - Endon.Functions.first/2","doc":"# get the first 3 posts, will return a list\n     posts = Post.first(3)\n\n     # get the first post, will return one item (or nil if none found)\n     post = Post.first()\n\n     # get the first 3 posts by author id 1\n     posts = Post.first(3, conditions: [author_id: 1])","ref":"Endon.Functions.html#first/2-examples"},{"type":"function","title":"Endon.Functions.last/2","doc":"Get the last `count` records.\n\nIf you ask for one thing (`count` of 1),\nyou will get back the last record or `nil` if none are found.  If you ask for more\nthan one thing (`count` > 1), you'll get back a list of 0 or more records.\n\nIf no order is defined it will order by primary key descending.","ref":"Endon.Functions.html#last/2"},{"type":"function","title":"Options - Endon.Functions.last/2","doc":"* `:order_by` - By default, orders by primary key ascending, and takes the last `count`\n    records.\n  * `:conditions` - Limit results to those matching these conditions.  Value can be\n    anything accepted by `where/2` (including a `t:Ecto.Query.t/0`).\n\nIf there is no primary key for the table then `:order_by` must be provided.","ref":"Endon.Functions.html#last/2-options"},{"type":"function","title":"Examples - Endon.Functions.last/2","doc":"# get the last 3 posts, will return a list\n     posts = Post.last(3)\n\n     # get the last post, will return one item\n     post = Post.last()\n\n     # get the last 3 posts by author id 1\n     posts = Post.last(3, conditions: [author_id: 1])","ref":"Endon.Functions.html#last/2-examples"},{"type":"function","title":"Endon.Functions.max/2","doc":"Get the maximum value of a given column.\n\n`conditions` are anything accepted by `where/2` (including a `t:Ecto.Query.t/0`).","ref":"Endon.Functions.html#max/2"},{"type":"function","title":"Endon.Functions.min/2","doc":"Get the minimum value of a given column.\n\n`conditions` are anything accepted by `where/2` (including a `t:Ecto.Query.t/0`).","ref":"Endon.Functions.html#min/2"},{"type":"function","title":"Endon.Functions.scope/1","doc":"Create a query with the given conditions (the same as `where/2` accepts).\n\nThis will not actually run the query, so you will need\nto pass the result to `where/2` or `c:Ecto.Repo.all/2`/`c:Ecto.Repo.one/2`.\n\nFor instance, this will just run one query to find a record with id 1 with name Bill.\n\n    Post.scope(id: 1) |> Post.scope(name: 'Bill') |> Post.first()\n\nThis is just a helpful function to make adding conditions easier to an existing `Ecto.Schema`","ref":"Endon.Functions.html#scope/1"},{"type":"function","title":"Endon.Functions.scope/2","doc":"Take a query and add conditions (the same as `where/2` accepts).\n\nThis will not actually run the query, so you will need\nto pass the result to `where/2` or `c:Ecto.Repo.all/2`/`c:Ecto.Repo.one/2`.\n\nFor instance:\n\n    existing_query = from x in Post\n    Post.scope(existing_query, id: 1) |> Post.first()\n\nThis is just a helpful function to make adding conditions easier to an existing query.","ref":"Endon.Functions.html#scope/2"},{"type":"function","title":"Endon.Functions.sum/2","doc":"Get the sum of a given column.\n\n`conditions` are anything accepted by `where/2` (including a `t:Ecto.Query.t/0`).","ref":"Endon.Functions.html#sum/2"},{"type":"function","title":"Endon.Functions.update/2","doc":"Update a record in the data store.\n\nThe `struct` must be a `t:Ecto.Schema.t/0` (your module that uses `Ecto.Schema`).\n`params` can be either a `Keyword` list or `Map` of attributes and values.\n\nReturns `{:ok, struct}` if one is created, or `{:error, changeset}` if there is\na validation error.","ref":"Endon.Functions.html#update/2"},{"type":"function","title":"Endon.Functions.update!/2","doc":"Update a record in the data store.\n\nThe `struct` must be a `t:Ecto.Schema.t/0` (your module that uses `Ecto.Schema`).\n`params` can be either a `Keyword` list or `Map` of attributes and values.\n\nReturns the struct if it was updated, or raises a `Ecto.InvalidChangesetError` if there was\na validation error.","ref":"Endon.Functions.html#update!/2"},{"type":"function","title":"Endon.Functions.update_where/2","doc":"Update multiple records in the data store based on conditions.\n\nUpdate all the records that match the given `conditions`, setting the given `params`\nas attributes.  `params` can be either a `Keyword` list or `Map` of attributes and values,\nand `conditions` is the same as for `where/2`.\n\nIt returns a tuple containing the number of entries and any returned result as second element.\nThe second element is nil by default unless a select is supplied in the update query.","ref":"Endon.Functions.html#update_where/2"},{"type":"function","title":"Endon.Functions.where/2","doc":"Fetch all entries that match the given conditions.\n\nThe conditions can be a `t:Ecto.Query.t/0` or a `t:Keyword.t/0`.","ref":"Endon.Functions.html#where/2"},{"type":"function","title":"Options - Endon.Functions.where/2","doc":"* `:order_by` - By default, no sort order is set\n  * `:preload` - A list of fields to preload, much like `c:Ecto.Repo.preload/3`\n  * `:offset` - Number to offset by\n  * `:limit` - Limit results to the given count\n  * `:lock` - Row level lock in the select. Currently only `:for_update` is supported.","ref":"Endon.Functions.html#where/2-options"},{"type":"function","title":"Examples - Endon.Functions.where/2","doc":"iex> User.where(id: 1)\n    iex> User.where(name: \"billy\", age: 23)\n    iex> User.where([name: \"billy\", age: 23], limit: 10, order_by: [desc: :id])\n    iex> query = from u in User, where: u.id > 10\n    iex> User.where(query, limit: 1)","ref":"Endon.Functions.html#where/2-examples"},{"type":"type","title":"Endon.Functions.where_conditions/0","doc":"Query conditions to use when selecting or updating records.","ref":"Endon.Functions.html#t:where_conditions/0"},{"type":"extras","title":"Endon","doc":"# Endon\n[![Build Status](https://github.com/parallel-markets/endon/actions/workflows/ci.yml/badge.svg)](https://github.com/parallel-markets/endon/actions/workflows/ci.yml)\n[![Hex pm](http://img.shields.io/hexpm/v/endon.svg?style=flat)](https://hex.pm/packages/endon)\n[![Hex pm](https://img.shields.io/hexpm/dt/endon.svg)](https://hex.pm/packages/endon)\n[![hex pm](https://img.shields.io/hexpm/l/endon.svg)](https://hex.pm/packages/endon)\n[![API Docs](https://img.shields.io/badge/api-docs-lightgreen.svg?style=flat)](https://hexdocs.pm/endon/)\n\nEndon is an Elixir library that provides helper functions for [Ecto](https://hexdocs.pm/ecto), with inspiration from Ruby on Rails' [ActiveRecord](https://guides.rubyonrails.org/active_record_basics.html).  It's designed to be used within a module that is an `Ecto.Schema` and provides helpful functions.\n\n##","ref":"readme.html"},{"type":"extras","title":"But why, Ecto is great - Endon","doc":"Yes, Ecto is great!  But there are a few things that are really annoying, and a little syntactic sugar can go a long way.  See the [Features](guides/features.md) page for more info.\n\n##","ref":"readme.html#but-why-ecto-is-great"},{"type":"extras","title":"What does Endon mean? - Endon","doc":"\"Ecto\" is a prefix from Greek έκτός (ektós) meaning \"outside\".  The opposite of Ecto is \"Endon\" (Greek ἔνδον) means \"within, inner, absorbing, or containing\".  Why the opposite of Ecto?  No good reason at all; naming is hard.","ref":"readme.html#what-does-endon-mean"},{"type":"extras","title":"Installation - Endon","doc":"To install Endon, just add an entry to your `mix.exs`:\n\n``` elixir\ndef deps do\n  [\n    # ...\n    {:endon, \"~> 1.0\"}\n  ]\nend\n```\n\n(Check [Hex](https://hex.pm/packages/endon) to make sure you're using an up-to-date version number.)","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Endon","doc":"In your `config/config.exs` you can set a few options:\n\n``` elixir\nconfig :endon,\n  repo: MyModule.Repo\n```\n\nThe `repo` should be the name of the [Ecto.Repo](https://hexdocs.pm/ecto/Ecto.Repo.html) in your application.  You can alternatively set this per schema module.","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - Endon","doc":"To get started, add `use Endon` to each module where you'd like to use it.  For example:\n\n``` elixir\ndefmodule User do\n  use Endon\n  # or, give the Repo module:\n  # use Endon, repo: MyApp.Repo\n\n  use Ecto.Schema\n\n  schema \"users\" do\n    field :name, :string\n    field :age, :integer, default: 0\n    has_many :posts, Post\n  end\nend\n```\n\nOnce Endon has been included, you can immediately use the helpful methods.\n\n``` elixir\n# get all users\nuser = User.all()\n\n# get first user\nuser = User.first()\n\n# get a user by id\nuser = User.find(1)\n\n# Iterate through all users in the DB efficiently (paginated, results are queried in\n# batches) and process them using a Stream\nEnum.each(User.stream_where(), &User.do_some_processing/1)\n\n# get a user by an attribute\nuser = User.find_by(name: \"billy\")\n\n# get the count of users\ncount = User.count()\n\n# create a new user\nuser = User.create!(name: \"snake\", age: 12)\n\n# update that user\nUser.update!(user, age: 23)\n\n# find all users that match criteria and preload Posts\nUser.where([age: 23], preload: :posts)\n\n# page through all users in batches\nUser.find_in_batches(fn batch ->\n  # we'll have a batch of 1,000 users here\n  Enun.each(batch, fn user ->\n    User.do_some_processing(user)\n  end)\nend)\n```","ref":"readme.html#usage"},{"type":"extras","title":"Running Tests - Endon","doc":"To run tests:\n\n``` shell\n$> mix test\n```","ref":"readme.html#running-tests"},{"type":"extras","title":"Reporting Issues - Endon","doc":"Please report all issues [on GitHub](https://github.com/parallel-markets/endon/issues).","ref":"readme.html#reporting-issues"},{"type":"extras","title":"Features","doc":"# Features","ref":"features.html"},{"type":"extras","title":"Schema Queries - Features","doc":"By setting an application-wide (or schema module specific) `Ecto.Repo` variable, your code doesn't have to mention the repo over and over (see [here](../README.md#configuration) for setup instructions).\n\n```elixir\n# Regular Ecto\nMyRepo.get_by(Post, title: \"My post\")\n\n# Endon\nPost.find_by(title: \"My post\")\n```","ref":"features.html#schema-queries"},{"type":"extras","title":"Find or Create By - Features","doc":"Let's say you want to make a `Post` with a title, unless it already exists in which case you want to just retrieve the record.  Ecto doesn't make this easy, because you have to build your own transaction:\n\n```elixir\nMyRepo.transaction(fn ->\n  Post\n  |> MyRepo.get_by(Post, title: \"My post\")\n  |> case do\n    nil ->\n      MyRepo.insert!(%Post{title: \"My post\"})\n    post ->\n      post\n  end\nend)\n```\n\nEndon makes it easy:\n\n```elixir\nPost.find_or_create_by(title: \"My post\")\n```","ref":"features.html#find-or-create-by"},{"type":"extras","title":"Easy Condiitions - Features","doc":"All of the `Endon` functions that act as selects can either take a `Ecto.Query` or a list of equality conditions.  For instance, to see if any records exist with a given title:\n\n```elixir\n# Regular Ecto\nquery = from p in Post, where: p.title == \"My post\"\nRepo.exists?(query)\n\n# Endon\nPost.exists?(title: \"My post\")\n```\n\nYou can even pass in `Ecto.Query`s:\n```elixir\nquery = from p in Post, where: p.like_count > 10\nPost.exists?(query)\n```","ref":"features.html#easy-condiitions"},{"type":"extras","title":"Preloading - Features","doc":"Endon makes preloading easy!\n\n```elixir\n# Regular Ecto\nPost |> MyRepo.get_by(id: 1) |> MyRepo.preload(:comments)\n\n# Endon\nPost.find_by(id: 1, preload: comments)\n```","ref":"features.html#preloading"},{"type":"extras","title":"And more! - Features","doc":"Want to get the first or last `n` records?  Easy:\n\n```elixir\n# Ecto\n# There's no short equivalent in Ecto, Ecto.Query.last gives only 1 record\n\n# Endon\nPost.last(10)\nPost.last(1, conditions: [author_id: 3])\n\n# Ecto\n# There's no short equivalent in Ecto, Ecot.Query.first gives only 1 record\n\n# Endon\nPost.first(3)\nPost.first(1, conditions: [author_id: 3])\n```\n\nWant to get a bunch of records given their ids?\n\n```elixir\n# Ecto\nMyRepo.all(from p in Post, where: p.id in [1,2,3])\n\n# Endon\nPost.find([1, 2, 3])\n```","ref":"features.html#and-more"}],"content_type":"text/markdown"}